ORG 00h
push cs
pop ds
xor ax,ax

;FOR DEBUG SKIP the whole detect bit
jmp loopyz

detect:
mov si,Print_loading
call printstring

mov si,executing
call printstring

;Check processor


push sp
pop ax
cmp ax,sp
jz short AtLeast286
WrongCPU:
mov si, oldCPU
call printstring
AtLeast286:        
mov word [bx + 24], WrongCPU    ; Install an exception handler
mov [bx + 26], bx
cwde                            ; and try a 32 bit instruction
mov si,goodCPU
call printstring

mov si,modemcom1
call printstring

mov ah,00h         ;initializing Serial Port Parameters
mov al,11101010b
           ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ;;;;;;;;Bits 1 to 3 are the Boud Rate       ;;;;;;;;
           ;;;;;;;;Bits 4 to 5 are the Parity          ;;;;;;;;
           ;;;;;;;;Bit 6 is the stop bits              ;;;;;;;;
           ;;;;;;;;Bits 7 to 8 are the Bits word length;;;;;;;;
           ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ; 111 = 9,600 boud rate
           ; 01  = odd Parity
           ; 0   = one stop bits
           ; 10  = 7 bits word length

mov dx,0           ; Port number com1
int 14h            ; Serial I/O services

mov ah,02h
mov dx,0
int 14h

mov ah,03h
mov dx,0
int 14h
xor ah,ah
cmp ax,0000000000000000b
jnz modemfoundcom1
mov si,nomodemcom1
call printstring
mov si,modemcom2
call printstring
mov ah,00h         ;initializing Serial Port Parameters
mov al,11101010b
           ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ;;;;;;;;Bits 1 to 3 are the Boud Rate       ;;;;;;;;
           ;;;;;;;;Bits 4 to 5 are the Parity          ;;;;;;;;
           ;;;;;;;;Bit 6 is the stop bits              ;;;;;;;;
           ;;;;;;;;Bits 7 to 8 are the Bits word length;;;;;;;;
           ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ; 111 = 9,600 boud rate
           ; 01  = odd Parity
           ; 0   = one stop bits
           ; 10  = 7 bits word length

mov dx,1           ; Port number com2
int 14h            ; Serial I/O services

xor ax,ax
mov ah,02h
mov dx,1
int 14h

mov ah,03h
mov dx,1
int 14h

xor ah,ah
cmp ax,0000000000000000b
jnz modemfoundcom2

mov si,nomodemcom2
call printstring
jmp nextstep
comonemodem db 'Com1'
comtwomodem db 'Com2'
modemfoundcom1:

mov si,modemfoundcom1msg
call printstring
jmp nextstep

modemfoundcom2:
mov si,comtwomodem
mov di,Modems
mov cx,5
rep movsb

mov al,48
mov byte [Modems],al

mov si,modemfoundcom2msg
call printstring
jmp nextstep

nextstep:
mov si,modemfound
call printstring

mov si,mouseps2
call printstring
mov si,nomouseps2
call printstring

;ps2 mouse

mov si,mousecom1
call printstring
mov si,nomousecom1
call printstring

;com1 serial mouse

mov si,mousecom2
call printstring
mov si,nomousecom2
call printstring
;com2 serial mouse

mov si,printerlpt1
call printstring

mov ah,01h
mov dx,0
int 17h

mov ah,02h
mov dx,0
int 17h
cmp ah,10000b
je foundprinterlpt1pm

mov si,noprinterlpt1
call printstring

mov si,printerlpt2
call printstring

mov ah,01h
mov dx,1
int 17h

mov ah,02h
mov dx,1
int 17h
cmp ah,10000b

je foundprinterlpt2pm
mov si,noprinterlpt2
call printstring

jmp endit

foundprinterlpt2pm:
mov si,foundprinterlpt2
call printstring
jmp endit

foundprinterlpt1pm:
mov si,foundprinterlpt1
call printstring
jmp endit

endit:

mov si,Writing_MODEMs
call printstring
;mov ah,03h
;mov al,1
;mov ch,1
;mov cl,1
;mov dh,0
;mov dl,0
;mov bx,ds
;mov es,bx
;mov bx,Modems
;int 13h
mov si,Modems
call printstring

mov si,Writing_MOUSEs
call printstring
mov si,Writing_PRINTERs
call printstring

loopyz:

;mov si,Loadingk
;call printstring

mov ah,02h               ;Load load Kernel to stack.
mov al,1
mov ch,0
mov cl,6
mov dh,0
mov dl,0
mov bx,0x1000
mov es,bx
mov bx,0x200
int 13h

jmp 1000h:200h

printstring:          ;Prints a string.
mov ah,0eh
stringloop:
lodsb
cmp al,00
je endstring
int 10h
jmp stringloop
endstring:
ret

goodCPU db 13,10,'386+ Detected',0
detectCPU db 13,10,'Detecting processor....',0
oldCPU db 13,10,'Warning, < 286 processor detected, may run incorrectly',0

Print_loading db 13,10,'Welcome to Easy OS v0.01a',0
executing     db 13,10,13,10,'Detecting devices...'
              db 13,10,'Bootinit is now searching ports for devices.',0

modemcom1     db 13,10,'Searching for modem on COM1...',0
modemcom2     db 13,10,'Searching for modem on COM2...',0
modemfoundcom1msg db ' Found a modem on COM1.',0
modemfoundcom2msg db ' Found a modem on COM2.',0
nomodemcom1 db ' No modem was found on COM1.',0
nomodemcom2 db ' No modem was found on COM2.',0

modemfound    db 13,10,'Modem Found : ',0

mouseps2      db 13,10,'Searching for PS2 mouse...',0
nomouseps2    db ' No PS2 mouse was found.',0
foundmouseps2 db ' Found a PS2 mouse.',0

mousecom1     db 13,10,'Searching for serial mouse on COM1...',0
nomousecom1   db ' No serial mouse on COM1 was found.',0
mousecom2     db 13,10,'Searching for serial mouse on COM2...',0
nomousecom2   db ' No serial mouse on COM2 was found.',0
foundmousecom1 db ' Found a Mouse on COM1.',0
foundmousecom2 db ' Found a Mouse on COM2.',0

printerlpt1   db 13,10,'Searching for printer on LPT1...',0
printerlpt2   db 13,10,'Searching for printer on LPT2...',0
foundprinterlpt1 db ' Found a Printer on LPT1.',0
foundprinterlpt2 db ' Found a Printer on LPT2.',0
noprinterlpt1 db ' No printer was found on LPT1.',0
noprinterlpt2 db ' No printer was found on LPT2.',0

Writing_PRINTERs db 13,10,'Writing /devices/PRINTERs.dev file.',0
Writing_MODEMs db 13,10,'Writing /devices/MODEMs.dev file.',0
Writing_MOUSEs  db 13,10,'Writing /devices/MOUSEs.dev file.',0
Loadingk db 13,10,'Loading The Easy OS Kernel v0.01a...',0
Modems times 512 db 0



