[ORG 0x200]
[BITS 16]

push cs
pop ds
jmp Pass_inc

%include "include\chsbuf.inc"
%include "include\errors.inc"

Pass_inc:
push cs
pop ds

xor bx,bx                             ;Clear BX
xor ax,ax                             ;Clear AX

mov ss,ax
mov ax,cs

cli
mov word [ss:(0x20*4)],Interupt_0x20_Handler
mov word [ss:(0x20*4+2)],ax
sti

jmp Bypass_Int_Handler

Interupt_0x20_Handler:          ;Int 0x20, Fuctions.
cmp ah,0x00
je short Print_a_String         ;Print's a String.
cmp ah,0x01
je short Load_CHS_to_Buffer     ;Loads CHS to memory.
cmp ah,0x02
je short Write_Buffer_to_CHS          ;Writes to CHS from memory.
cmp ah,0x03              
je short Clear_Screen                 ;Clears the screen
ret

Print_a_String:                 ;Prints a string using int 0x10 func 0x00e.
Push ax                         ;String gets terminated by 0.
mov ah,0x00e
Print_a_String_Loop:
lodsb
cmp al,0x00
je Print_a_String_Loop_End
int 0x10
jmp Print_a_String_Loop
Print_a_String_Loop_End:
pop ax
ret

Load_CHS_to_Buffer:             ;Loads CHS to memory buffer.
xor al,al
mov al,1

Load_CHS_to_Buffer_retry:
inc al
push ax
mov ah,0x03
mov al,Num_of_Sectors       
mov ch,Num_of_Cyl
mov cl,Starting_at_Sector
mov dh,Head_Number
mov dl,0
mov bx,0x1000
mov es,bx
mov bx,0x100
int 0x13
pop ax
cmp al,3
je short Disk_R_Error
jc Load_CHS_to_Buffer_retry           ;If carry is set then retrys.
xor ax,ax
ret

Write_Buffer_to_CHS:             ;Writes the memory buffer to CHS. 
xor al,al
mov al,1

Write_Buffer_to_CHS_retry:
inc al
push ax
mov ah,0x03
mov al,Num_of_Sectors       
mov ch,Num_of_Cyl
mov cl,Starting_at_Sector
mov dh,Head_Number
mov dl,0
mov bx,0x1000
mov es,bx
mov bx,0x100
int 0x13
pop ax
cmp al,3
je short Disk_W_Error
jc Write_Buffer_to_CHS_retry           ;If carry is set then retrys.
xor ax,ax
ret
Disk_W_Error:
mov ah,0x00
mov si,Disk_W_Error_MSG
int 0x20
ret
Disk_R_Error:
mov ah,0x00
mov si,Disk_R_Error_MSG
int 0x20
ret

Clear_Screen:
mov ah,0x00
mov al,0x03
int 0x10
ret
Bypass_Int_Handler:



mov ah,02h               ;Load failsafe to stack.
mov al,3
mov ch,0
mov cl,7                 ;The failsafe is only loaded here because there is
mov dh,0                 ;no gui yet.
mov dl,0
mov bx,0x1000
mov es,bx
mov bx,0x500
int 13h
jmp 1000h:500h
                                       ;This is Where The Easy OS GUI
                                       ;will get setup and loaded.
