ORG 00h
push cs
pop ds
xor ax,ax


mov si,Print_loading
call printstring

mov si,executing
call printstring


jmp a20 ;enable the a20 line to allow 1mb< memory

detect:


;Check processor
push sp
pop ax
cmp ax,sp
jz short AtLeast286
WrongCPU:
mov si, oldCPU
call printstring
AtLeast286:        
mov word [bx + 24], WrongCPU    ; Install an exception handler
mov [bx + 26], bx
cwde                            ; and try a 32 bit instruction
mov si,goodCPU
call printstring



mov si,modemcom1
call printstring

mov ah,00h         ;initializing Serial Port Parameters
mov al,11101010b
           ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ;;;;;;;;Bits 1 to 3 are the Boud Rate       ;;;;;;;;
           ;;;;;;;;Bits 4 to 5 are the Parity          ;;;;;;;;
           ;;;;;;;;Bit 6 is the stop bits              ;;;;;;;;
           ;;;;;;;;Bits 7 to 8 are the Bits word length;;;;;;;;
           ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ; 111 = 9,600 boud rate
           ; 01  = odd Parity
           ; 0   = one stop bits
           ; 10  = 7 bits word length

mov dx,0           ; Port number com1
int 14h            ; Serial I/O services

mov ah,02h
mov dx,0
int 14h

mov ah,03h
mov dx,0
int 14h
xor ah,ah
cmp ax,0000000000000000b
jnz modemfoundcom1
mov si,nomodemcom1
call printstring
mov si,modemcom2
call printstring
mov ah,00h         ;initializing Serial Port Parameters
mov al,11101010b
           ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ;;;;;;;;Bits 1 to 3 are the Boud Rate       ;;;;;;;;
           ;;;;;;;;Bits 4 to 5 are the Parity          ;;;;;;;;
           ;;;;;;;;Bit 6 is the stop bits              ;;;;;;;;
           ;;;;;;;;Bits 7 to 8 are the Bits word length;;;;;;;;
           ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ; 111 = 9,600 boud rate
           ; 01  = odd Parity
           ; 0   = one stop bits
           ; 10  = 7 bits word length

mov dx,1           ; Port number com2
int 14h            ; Serial I/O services

xor ax,ax
mov ah,02h
mov dx,1
int 14h

mov ah,03h
mov dx,1
int 14h

xor ah,ah
cmp ax,0000000000000000b
jnz modemfoundcom2

mov si,nomodemcom2
call printstring
jmp nextstep
comonemodem db 'Com1'
comtwomodem db 'Com2'
modemfoundcom1:

mov si,modemfoundcom1msg
call printstring
jmp nextstep

modemfoundcom2:
mov si,comtwomodem
mov di,Modems
mov cx,5
rep movsb

mov al,48
mov byte [Modems],al

mov si,modemfoundcom2msg
call printstring
jmp nextstep

nextstep:
mov si,modemfound
call printstring

mov si,mouseps2
call printstring
mov si,nomouseps2
call printstring

;ps2 mouse

mov si,mousecom1
call printstring
mov si,nomousecom1
call printstring

;com1 serial mouse

mov si,mousecom2
call printstring
mov si,nomousecom2
call printstring
;com2 serial mouse

mov si,printerlpt1
call printstring

mov ah,01h
mov dx,0
int 17h

mov ah,02h
mov dx,0
int 17h
cmp ah,10000b
je foundprinterlpt1pm

mov si,noprinterlpt1
call printstring

mov si,printerlpt2
call printstring

mov ah,01h
mov dx,1
int 17h

mov ah,02h
mov dx,1
int 17h
cmp ah,10000b

je foundprinterlpt2pm
mov si,noprinterlpt2
call printstring

jmp endit

foundprinterlpt2pm:
mov si,foundprinterlpt2
call printstring
jmp endit

foundprinterlpt1pm:
mov si,foundprinterlpt1
call printstring
jmp endit

endit:

mov si,Writing_MODEMs
call printstring
;mov ah,03h
;mov al,1
;mov ch,1
;mov cl,1
;mov dh,0
;mov dl,0
;mov bx,ds
;mov es,bx
;mov bx,Modems
;int 13h
mov si,Modems
call printstring

mov si,Writing_MOUSEs
call printstring
mov si,Writing_PRINTERs
call printstring

loopyz:

mov si,Loadingk
call printstring

mov ah,02h               ;Load load Kernel to memory.
mov al,1
mov ch,0
mov cl,6
mov dh,0
mov dl,0
mov bx,0x1000
mov es,bx
mov bx,0x200
int 13h

jmp 1000h:200h

printstring:          ;Prints a string.
mov ah,0eh
stringloop:
lodsb
cmp al,00
je endstring
int 10h
jmp stringloop
endstring:
ret







;enable the a20 line
;
;found the detect code in 'osd'
a20:
call enablea20test
jnz  enable_A20 ;enable a20 line
jz runningwin
jmp detect
ret

runningwin:
mov si,enableda20
call printstring
jmp detect


enable_A20:
	cli

	call    a20wait
	mov     al,0xAD
	out     0x64,al

	call    a20wait
	mov     al,0xD0
	out     0x64,al

	call    a20wait2
	in      al,0x60
	push    eax

	call    a20wait
	mov     al,0xD1
	out     0x64,al

	call    a20wait
	pop     eax
	or      al,2
	out     0x60,al

        call    a20wait
	mov     al,0xAE
	out     0x64,al

	call    a20wait
	ret

a20wait:
.l0:	mov     ecx,65536
.l1:	in      al,0x64
	test    al,2
	jz      .l2
	loop    .l1
	jmp     .l0
.l2:	ret


a20wait2:
.l0:	mov     ecx,65536
.l1:	in      al,0x64
	test    al,1
	jnz     .l2
        loop    .l1
	jmp     .l0
.l2:	ret

enablea20test:                          ; test for enabled A20
        mov al,byte [fs:0]                   ; get byte from 0:0
        mov ah,al                       ; preserve old byte
        not al                          ; modify byte
        xchg al,byte [gs:10h]                ; put modified byte to 0ffffh:10h
        cmp ah,byte [fs:0]                   ; set zero if byte at 0:0 not modified
        mov [gs:10h],al                 ; put back old byte at 0ffffh:10h
        ret                             ; return, zero if A20 enabled


Print_loading db 13,10,'Welcome to Easy OS v0.01a',0
executing     db 13,10,13,10,'Detecting devices...'
              db 13,10,'Bootinit is now searching ports for devices.',0

modemcom1     db 13,10,'Searching for modem on COM1...',0
modemcom2     db 13,10,'Searching for modem on COM2...',0
modemfoundcom1msg db ' Found a modem on COM1.',0
modemfoundcom2msg db ' Found a modem on COM2.',0
nomodemcom1 db ' No modem was found on COM1.',0
nomodemcom2 db ' No modem was found on COM2.',0

modemfound    db 13,10,'Modem Found : ',0

mouseps2      db 13,10,'Searching for PS2 mouse...',0
nomouseps2    db ' No PS2 mouse was found.',0
foundmouseps2 db ' Found a PS2 mouse.',0

mousecom1     db 13,10,'Searching for serial mouse on COM1...',0
nomousecom1   db ' No serial mouse on COM1 was found.',0
mousecom2     db 13,10,'Searching for serial mouse on COM2...',0
nomousecom2   db ' No serial mouse on COM2 was found.',0
foundmousecom1 db ' Found a Mouse on COM1.',0
foundmousecom2 db ' Found a Mouse on COM2.',0

printerlpt1   db 13,10,'Searching for printer on LPT1...',0
printerlpt2   db 13,10,'Searching for printer on LPT2...',0
foundprinterlpt1 db ' Found a Printer on LPT1.',0
foundprinterlpt2 db ' Found a Printer on LPT2.',0
noprinterlpt1 db ' No printer was found on LPT1.',0
noprinterlpt2 db ' No printer was found on LPT2.',0

Loading_Kernal db 13,10,13,10,'Loading kernal to setup Shell.',0
Writing_PRINTERs db 13,10,'Writing /devices/PRINTERs.dev file.',0
Writing_MODEMs db 13,10,'Writing /devices/MODEMs.dev file.',0
Writing_MOUSEs  db 13,10,'Writing /devices/MOUSEs.dev file.',0
Loadingk db 13,10,'Loading The Easy OS Kernel v0.01a...',0
Modems times 512 db 0

goodCPU db 13,10,'386+ Detected',0
detectCPU db 13,10,'Detecting processor....',0
oldCPU db 13,10,'Warning, < 286 processor detected, may run incorrectly',0

enablea20 db 13,10,'Loading full memory through the A20 line',0
enableda20 db 13,10,'Warning: A20 memory enabled. Running Windows?',0

